`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    16:21:41 04/07/2016 
// Design Name: 
// Module Name:    lab06_1 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
`define KEYPAD_ROW_WIDTH 4  // Row width of keypad
`define KEYPAD_COL_WIDTH 4  // column width of keypad
module lab06_1(
   clk, // scan clock
	rst_n, // active low reset
	col_n, // pressed column index
	row_n, // scanned row index
	pressed, // whether key pressed (1) or not (0)
	ftsd_ctl, // ftsd display control signal
	display // 14-segment display output
	 );

	input clk; // scan clock
	input rst_n; // active low reset
	input [`KEYPAD_COL_WIDTH-1:0] col_n; // pressed_detected col_numn index
	output [`KEYPAD_ROW_WIDTH-1:0] row_n; // scanned row_n index
	output pressed; // whether key pressed (1) or not (0)
	output ftsd_ctl; // ftsd display control signal
	output [14:0]display; // 14-segment display output
	
	wire clk_debounce;
	wire [1:0] ftsd_ctl_en; // divided clock for scan control
	wire [3:0] key; // returned pressed_detected key
	wire [3:0] ftsd_in;// 14 segment display control (in the always block)
	wire [3:0] ftsd_ctl; // scan control for 14-segment display
	wire [3:0] in0, in1, in2, in3;
	
	freq_div U0(
	.clk_out(clk_debounce), // divided clock output
	.clk_ctl(ftsd_ctl_en), // divided clock output for scan freq
	.clk(clk), // global clock input
	.rst_n(rst_n) // active low reset
	);
	
	ftsd U1(
	.display(display), // 14-segment display output
	.bcd(ftsd_in) // BCD input
	);
	
	keypad_scan U2(
	.clk(clk_debounce), // scan clock
	.rst_n(rst_n), // active low reset
	.col_n(col_n), // pressed_detected col_numn index
	.row_n(row_n), // scanned row_n index
	.key(key), // returned pressed_detected key
	.pressed(pressed) // whether key_detected pressed_detected (1) or not (0)
	);
	
	scan_ctl U3(
	.ftsd_ctl(ftsd_ctl), // ftsd display control signal
	.ftsd_in(ftsd_in), // output to ftsd display
	.in0(4'd0), // 1st input
	.in1(4'd0), // 2nd input	
	.in2(4'd0),// 3rd input
	.in3(key), // 4th input		
	.ftsd_ctl_en(ftsd_ctl_en) // divided clock for scan control
	);
	
endmodule
